# powm(): calculate the modular power: r = base ^ e % n
# The used algorithm is square & multiply, see http://en.wikipedia.org/wiki/Exponentiation_by_squaring

function powm(base,e,n,r,t)
{
   r=1
   t=base
   while(e > 0){
      if(and(e, 1) > 0)r = r * t % n
      e = rshift(e,1)
      t = t * t % n
   }
   return r
}

/^#/{}                        # comment line, ignore
/^[ \t]*$/{ print }           # empty line, print it out
/^@/{ print substr($0,2) }    # header line

/^a/{ print "a: " powm($2,$3,$4); }
/^b/{ print "awk: " powm($2,$3,$4); print "gmp: " $2 ^ $3 % $4 }
/^g/{ print $2 ^ $3 % $4 }
/^[0-9]/{ print powm($1,$2,$3); }
